Loading...
Searching...
No Matches
Sip_supported

## Macros

#define | sip_supported(sip)
| Access a SIP Supported header structure sip_supported_t from sip_t.
#define | SIP_SUPPORTED_INIT()
| Initializer for structure sip_supported_t.
#define | SIPTAG_SUPPORTED(x)
| Tag list item for pointer to a Supported header structure sip_supported_t.
#define | SIPTAG_SUPPORTED_REF(x)
| Tag list item for reference to a Supported header pointer.
#define | SIPTAG_SUPPORTED_STR(s)
| Tag list item for string with Supported header value.
#define | SIPTAG_SUPPORTED_STR_REF(x)
| Tag list item for reference to a Supported header string.

## Typedefs

typedef msg_list_t | sip_supported_t
| @

## Functions

issize_t | sip_supported_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Supported header.
issize_t | sip_supported_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Supported header.
sip_supported_t * | sip_supported_init (sip_supported_t x[1])
| Initialize a structure sip_supported_t.
int | sip_is_supported (sip_header_t const *header)
| Test if header object is instance of sip_supported_t.
sip_supported_t * | sip_supported_dup (su_home_t *home, sip_supported_t const *hdr))
| Duplicate a list of Supported header header structures sip_supported_t.
sip_supported_t * | sip_supported_copy (su_home_t *home, sip_supported_t const *hdr))
| Copy a list of Supported header header structures sip_supported_t.
sip_supported_t * | sip_supported_make (su_home_t *home, char const *s))
| Make a Supported header structure sip_supported_t.
sip_supported_t * | sip_supported_format (su_home_t *home, char const *fmt,...)))
| Make a Supported header from formatting result.

## Variables

msg_hclass_t | sip_supported_class []
| Header class for Supported header.
tag_typedef_t | siptag_supported
| Tag for Supported header object.
tag_typedef_t | siptag_supported_str
| Tag for string with Supported header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SUPPORTED_INIT

#define SIP_SUPPORTED_INIT | ( |  | ) |

Initializer for structure sip_supported_t.

A static sip_supported_t structure for Supported header must be initialized with the SIP_SUPPORTED_INIT() macro. For instance,

sip_supported_t sip_supported = SIP_SUPPORTED_INIT;
sip_supported
#define sip_supported(sip)
Access a SIP Supported header structure sip_supported_t from sip_t.
Definition sip_protos.h:8223
sip_supported_t
msg_list_t sip_supported_t
@
Definition sip.h:195
SIP_SUPPORTED_INIT
#define SIP_SUPPORTED_INIT()
Initializer for structure sip_supported_t.
Definition sip_protos.h:8240

## SIPTAG_SUPPORTED

#define SIPTAG_SUPPORTED | ( |  | x | ) |

Tag list item for pointer to a Supported header structure sip_supported_t.

The SIPTAG_SUPPORTED() macro is used to include a tag item with a pointer to a sip_supported_t structure in a tag list.

Parameters

  x | pointer to a sip_supported_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SUPPORTED_REF().

## SIPTAG_SUPPORTED_STR

#define SIPTAG_SUPPORTED_STR | ( |  | s | ) |

Tag list item for string with Supported header value.

The SIPTAG_SUPPORTED_STR() macro is used to include a tag item with a string containing value of a sip_supported_t header in a tag list.

Parameters

  s | pointer to a string containing Supported header value, or NULL.

The string in SIPTAG_SUPPORTED_STR() can be converted to a sip_supported_t header structure by giving the string s has second argument to function sip_supported_make().

The corresponding tag taking reference parameter is SIPTAG_SUPPORTED_STR_REF().

## Typedef Documentation

## sip_supported_t

typedef msg_list_t sip_supported_t

@

The Supported header enumerates all the capabilities of the client or server. Its syntax is defined in RFC 3261 as follows:

Supported = ( "Supported" / "k" ) HCOLON
[option-tag *(COMMA option-tag)]

The parsed option-tags of Supported header are stored in sip_supported_t structure.

The structure sip_supported_t contains representation of an Supported header.

The sip_supported_t is defined as follows:

typedef struct msg_list_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
} sip_supported_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
msg_list_s
msg_list_s::k_common
msg_common_t k_common[1]
msg_list_s::k_next
msg_list_t * k_next
msg_list_s::k_items
msg_param_t * k_items

## Function Documentation

## sip_is_supported()

int sip_is_supported | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_supported_t.

Check if the header class is an instance of Supported header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header supported
  0 | (false) otherwise

## sip_supported_copy()

sip_supported_t * sip_supported_copy | ( | su_home_t * | home,
|  | sip_supported_t const * | hdr )

inline

Copy a list of Supported header header structures sip_supported_t.

The function sip_supported_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  supported = sip_supported_copy(home, sip->sip_supported);
  sip_supported_copy
  sip_supported_t * sip_supported_copy(su_home_t *home, sip_supported_t const *hdr))
  Copy a list of Supported header header structures sip_supported_t.
  Definition sip_protos.h:8370

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_supported_dup()

sip_supported_t * sip_supported_dup | ( | su_home_t * | home,
|  | sip_supported_t const * | hdr )

inline

Duplicate a list of Supported header header structures sip_supported_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  supported = sip_supported_dup(home, sip->sip_supported);
  sip_supported_dup
  sip_supported_t * sip_supported_dup(su_home_t *home, sip_supported_t const *hdr))
  Duplicate a list of Supported header header structures sip_supported_t.
  Definition sip_protos.h:8327

Returns
  A pointer to the newly duplicated sip_supported_t header structure, or NULL upon an error.

## sip_supported_format()

sip_supported_t * sip_supported_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Supported header from formatting result.

Make a new sip_supported_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_supported_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_supported_init()

sip_supported_t * sip_supported_init | ( | sip_supported_t | x[1] | ) |

inline

Initialize a structure sip_supported_t.

An sip_supported_t structure for Supported header can be initialized with the sip_supported_init() function/macro. For instance,

sip_supported_t sip_supported;
sip_supported_init(&sip_supported);
sip_supported_init
sip_supported_t * sip_supported_init(sip_supported_t x[1])
Initialize a structure sip_supported_t.
Definition sip_protos.h:8258

## sip_supported_make()

sip_supported_t * sip_supported_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Supported header structure sip_supported_t.

The function sip_supported_make() makes a new sip_supported_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_supported_t header structure, or NULL upon an error.

## Variable Documentation

## sip_supported_class

msg_hclass_t sip_supported_class[]

extern

Header class for Supported header.

The header class sip_supported_class defines how a SIP Supported header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_supported_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.